/*
* General porpouse functions. 
*
*/

#ifndef UTIL_H
#define UTIL_H

#include "Defines.h"
#include "GeneralTypes.h"

/* General definitions. */
#define	DEFAULT_OUT_FILE	"/dev/stdout"
#define	DEFAULT_ERROR_FILE	"/dev/stderr"
#define	DEFAULT_DEBUG_FILE	"/dev/stderr"

/* 
*
* Frees the previous allocated area and then points it to null. 
*
* Parameters:
*
*	_pointer: pointer to the previous allocated area. 			
*
* Returns:
*
*/
void sfree(void **_pointer);

/* 
*
* Gets current timestamp. 
*
* Parameters:
*
* Returns:
*
*	Current timestamp.
*
*/
long int getCurrentTimestamp(void);

/* 
*
* Informs a message to the specified file.. 
*
* Parameters:
*
*	_file: where to inform message.
*	_identifier: something that identifies the message.
*	_format: message format.	
*
* Returns:
*
*	Success if message could be informed.
*	Failure if message could not be informed.	
*
*/
BOOLEAN inform(const char *_file, const char *_identifier, const char *_format, ...);

/* 
*
* Informs a message to the specified file if necessary. 
*
* Parameters:
*
*	_debug: defines if message should or should not be informed.
*	_file: where to inform message.
*	_identifier: something that identifies the message.
*	_format: message format.	
*
* Returns:
*
*	Success if message could be informed.
*	Failure if message could not be informed.	
*
*/
BOOLEAN debug(short int _debug, const char *_file, const char *_identifier, const char *, ...);

#endif
